package cn.estsh.i3plus.ext.mes.pcn.pojo.context;

import cn.estsh.i3plus.ext.mes.pcn.pojo.util.MesPcnExtConstWords;
import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.mes.bean.MesProductionAssembly;
import cn.estsh.i3plus.pojo.mes.bean.MesWorkOrderAssembly;
import cn.estsh.i3plus.pojo.mes.util.MesExtEnumUtil;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.util.StringUtils;

import java.io.Serializable;

/**
 * 生产过程上下文对象-装配件清单信息（排序）
 */
@Data
public class MesProductionAssemblySortContext extends MesProductionAssemblyContext implements Serializable {

    private static final long serialVersionUID = -1492128619505737538L;

    @ApiParam(value = "零件条码")
    private String productSn;

    @ApiParam(value = "工艺顺序号")
    private Integer processSeq;

    @ApiParam(value = "生产零件号")
    private String productPartNo;

    @ApiParam(value = "汇报零件号")
    private String reportPartNo;

    @ApiParam(value = "零件类型")
    private String partTypeCode;

    @ApiParam(value = "VPPS码")
    private String vppsCode;

    @ApiParam(value = "车型代码")
    private String vehicleNo;

    @ApiParam(value = "车系")
    private String vehicleClassNo;

    @ApiParam(value = "显示顺序")
    private Integer displaySeq;

    @ApiParam(value = "显示内容")
    private String displayValue;

    @ApiParam(value = "显示规则")
    private String displayRule;

    @ApiParam(value = "动作代码")
    private String actionCode;

    @ApiParam(value = "动作名称")
    private String actionName;

    @ApiParam(value = "汇报方式")
    private Integer reportType;

    @ApiParam(value = "SAP来源库位")
    private String srcErpLocation;

    @ApiParam(value = "SAP目标库位")
    private String destErpLocation;

    @ApiParam(value = "条码打印方式")
    private Integer printType;

    @ApiParam(value = "条码打印机")
    private String printer;

    @ApiParam(value = "条码打印模板")
    private String printTemplate;

    @ApiParam(value = "是否启动组合条码")
    private String isCombineSn;

    @ApiParam(value = "逻辑数量")
    private Double logicNum;

    @ApiParam(value = "是否启用逻辑数量")
    private Integer isLogicNum;

    @ApiParam(value = "显示颜色")
    private String showColor;

    @ApiParam(value = "是否保存过程工艺参数")
    private Integer isSaveProcessParam ;

    @ApiParam(value = "是否保存过程工艺参数类型")
    private Integer isSaveProcessParamType;

    @ApiParam(value = "扫描条码载取符")
    private String delimiter;

    @ApiParam(value = "生产组代码")
    private String productGroupCode;

    public MesProductionAssemblySortContext() {}

    public MesProductionAssemblySortContext copy(MesWorkOrderAssembly workOrderAssembly, MesProductionAssembly productionAssembly) {

        if (null != workOrderAssembly) BeanUtils.copyProperties(workOrderAssembly, this);

        if (null != productionAssembly) BeanUtils.copyProperties(productionAssembly, this);

        if (StringUtils.isEmpty(this.routeSeq)) this.routeSeq = MesPcnExtConstWords.ZERO;

        if (StringUtils.isEmpty(this.isSkip)) this.isSkip = CommonEnumUtil.TRUE_OR_FALSE.FALSE.getValue();

        if (this.assemblyStatus.compareTo(MesExtEnumUtil.ASSEMBLY_STATUS.ASSEMBLY_STATUS_30.getValue()) == 0 &&
                (MesExtEnumUtil.ASSEMBLY_MATCH_TYPE.MATCH_TYPE_50.getValue() == this.matchType || MesExtEnumUtil.ASSEMBLY_MATCH_TYPE.MATCH_TYPE_60.getValue() == this.matchType))
            this.assemblyStatus = MesExtEnumUtil.ASSEMBLY_STATUS.ASSEMBLY_STATUS_10.getValue();

        if (this.assemblyStatus.compareTo(MesExtEnumUtil.ASSEMBLY_STATUS.ASSEMBLY_STATUS_30.getValue()) != 0) this.isResetScan = CommonEnumUtil.TRUE_OR_FALSE.FALSE.getValue();

        return this;
    }

    public MesProductionAssemblySortContext assemblyStatus() {
        this.assemblyStatus = MesExtEnumUtil.ASSEMBLY_STATUS.ASSEMBLY_STATUS_10.getValue();
        return this;
    }

    public MesProductionAssemblySortContext assemblySn(String assemblySn) {
        this.assemblySn = assemblySn;
        return this;
    }

}
